/*
 * 
 */
package net.officefloor.model.gwt.module;

import java.util.List;
import java.util.LinkedList;

import javax.annotation.Generated;

import net.officefloor.model.AbstractModel;
import net.officefloor.model.ItemModel;
import net.officefloor.model.RemoveConnectionsAction;

@Generated("net.officefloor.model.generate.ModelGenerator")
public class GwtModuleModel extends AbstractModel implements ItemModel<GwtModuleModel> {

    public static enum GwtModuleEvent {
     CHANGE_RENAME_TO, CHANGE_ENTRY_POINT_CLASS_NAME, ADD_INHERIT, REMOVE_INHERIT
    }

    /**
     * Default constructor.
     */
    public GwtModuleModel() {
    }

    /**
     * Convenience constructor.
     */
    public GwtModuleModel(
      String renameTo
    , String entryPointClassName
    , String[] inherit
    ) {
        this.renameTo = renameTo;
        this.entryPointClassName = entryPointClassName;
        if (inherit != null) {
            for (String model : inherit) {
                this.inherit.add(model);
            }
        }
    }

    /**
     * Convenience constructor allowing XY initialising.
     */
    public GwtModuleModel(
      String renameTo
    , String entryPointClassName
    , String[] inherit
    , int x
    , int y
    ) {
        this.renameTo = renameTo;
        this.entryPointClassName = entryPointClassName;
        if (inherit != null) {
            for (String model : inherit) {
                this.inherit.add(model);
            }
        }
        this.setX(x);
        this.setY(y);
    }

    /**
     * Rename to.
     */
    private String renameTo;

    public String getRenameTo() {
        return this.renameTo;
    }

    public void setRenameTo(String renameTo) {
        String oldValue = this.renameTo;
        this.renameTo = renameTo;
        this.changeField(oldValue, this.renameTo, GwtModuleEvent.CHANGE_RENAME_TO);
    }

    /**
     * Entry point class name.
     */
    private String entryPointClassName;

    public String getEntryPointClassName() {
        return this.entryPointClassName;
    }

    public void setEntryPointClassName(String entryPointClassName) {
        String oldValue = this.entryPointClassName;
        this.entryPointClassName = entryPointClassName;
        this.changeField(oldValue, this.entryPointClassName, GwtModuleEvent.CHANGE_ENTRY_POINT_CLASS_NAME);
    }


    /**
     * Inherit.
     */
    private List<String> inherit = new LinkedList<String>();

    public List<String> getInherits() {
        return this.inherit;
    }

    public void addInherit(String inherit) {
        this.addItemToList(inherit, this.inherit, GwtModuleEvent.ADD_INHERIT);
    }

    public void removeInherit(String inherit) {
        this.removeItemFromList(inherit, this.inherit, GwtModuleEvent.REMOVE_INHERIT);
    }


    /**
     * Remove Connections.
     */
    public RemoveConnectionsAction<GwtModuleModel> removeConnections() {
        RemoveConnectionsAction<GwtModuleModel> _action = new RemoveConnectionsAction<GwtModuleModel>(this);
        return _action;
    }
}
